Index: /trunk/SophyaProg/PMixer/skymixer.cc
===================================================================
--- /trunk/SophyaProg/PMixer/skymixer.cc	(revision 3050)
+++ /trunk/SophyaProg/PMixer/skymixer.cc	(revision 3051)
@@ -806,5 +806,5 @@
     }
   if (debuglev > 4) {  // Writing the input map to the outppf
-    SphereHEALPix<float> ings(sqrt((double)finalMap.NbPixels()/12));
+    SphereHEALPix<float> ings((int)sqrt((double)finalMap.NbPixels()/12));
     for(int i=0; i<finalMap.NbPixels(); i++)
       {
@@ -856,5 +856,5 @@
       cout << "nb pixels: " << finalMap.NbPixels() << endl;
     }
-  SphereHEALPix<T> bigBetaMap(sqrt((double)nbpix/12));
+  SphereHEALPix<T> bigBetaMap((int)sqrt((double)nbpix/12));
   if(nbpix != betaMap.NbPixels())
     {
Index: /trunk/SophyaProg/PMixer/smakefile
===================================================================
--- /trunk/SophyaProg/PMixer/smakefile	(revision 3050)
+++ /trunk/SophyaProg/PMixer/smakefile	(revision 3051)
@@ -67,5 +67,4 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)specrespvector.h \
-  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)squarefilt.h \
   $(SOPHYAINCP)gaussfilt.h \
@@ -77,26 +76,23 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fioarr.h \
-  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -109,5 +105,4 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
-  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -119,5 +114,4 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
-  $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
@@ -131,5 +125,4 @@
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
-  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -151,26 +144,23 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fioarr.h \
-  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -183,5 +173,4 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
-  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -193,5 +182,4 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
-  $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
@@ -205,5 +193,4 @@
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
-  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -225,26 +212,23 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fioarr.h \
-  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -257,5 +241,4 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
-  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -267,5 +250,4 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
-  $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
@@ -279,5 +261,4 @@
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
-  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -295,29 +276,27 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  Sph2Sph.cc
  
-$(SOPHYAOBJP)tgrsr.o: tgrsr.cc $(SOPHYAINCP)sopnamsp.h \
-  pmixer.h $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
+$(SOPHYAOBJP)tgrsr.o: tgrsr.cc \
+  $(SOPHYAINCP)sopnamsp.h pmixer.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fioarr.h \
-  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -330,5 +309,4 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
-  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -340,5 +318,4 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
-  $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
@@ -352,5 +329,4 @@
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
-  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \
@@ -368,29 +344,27 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tgrsr.cc
  
-$(SOPHYAOBJP)tgsky.o: tgsky.cc $(SOPHYAINCP)sopnamsp.h \
-  pmixer.h $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
+$(SOPHYAOBJP)tgsky.o: tgsky.cc \
+  $(SOPHYAINCP)sopnamsp.h pmixer.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fioarr.h \
-  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)longlat.h \
@@ -403,5 +377,4 @@
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
-  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)datacards.h \
   $(SOPHYAINCP)ntuple.h \
@@ -413,5 +386,4 @@
   $(SOPHYAINCP)spherepos.h \
   $(SOPHYAINCP)unitvector.h \
-  $(SOPHYAINCP)vector3d.h \
   $(SOPHYAINCP)datatype.h \
   $(SOPHYAINCP)spherehealpix.h \
@@ -425,5 +397,4 @@
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)cimage.h \
-  $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)radspecvector.h \
   $(SOPHYAINCP)radspec.h \