Index: /trunk/SophyaLib/Manual/modifs.tex
===================================================================
--- /trunk/SophyaLib/Manual/modifs.tex	(revision 3060)
+++ /trunk/SophyaLib/Manual/modifs.tex	(revision 3061)
@@ -273,6 +273,10 @@
 
 \section{HiStats} 
-\subsection{Classe HistoErr } 
-Ajout classe HistoErr (Septembre-Octobre 2004) 
+\subsection{Classe Histo,HProf,HistoErr,Histo2D } 
+\noindent
+- Aout 2006 : refonte profonde des allocations memoire et delete de
+ Histo,HProf,HistoErr,Histo2D pour faciliter la gestion des IO FITS. \\
+- Sept 2004 : Ajout classe HistoErr. 
+C'est un Histo qui garde le nombre d'entr\'ees dans chaque bin) \\
 
 \subsection{NTuple}
@@ -495,5 +499,10 @@
 \end{verbatim}
 
-\item[\rond] Tests et vrifications des polynomes de Legendre CMV ???
+\item[\rond] {\bf Fin 2004} : Tests et vrifications des polynomes de Legendre.
+La classe LambdaLMBuilder donne les bons r\'esultats mais calcule les Plm
+pour tous les $l,m$.
+Introduction d'une routine (C-like) ``HarmSph\_array\_teta'' qui calcule
+les Plm pour $m$ fix\'e et $l\in [0,l_{max}]$ comme ce qui est fait
+dans la GSL... (la routine GSL ne marche pas corectement).
 \end{itemize}
 
@@ -794,8 +803,13 @@
 
 \section{FitsIOServer}
-Juin 2006 : \\
+\noindent
+- Aout 2006 : \\
+Ecriture/Lecture des classes Histo,HProf,HistoErr,Histo2D dans fichier FITS.
+Les Histo2D et leurs projections 1D associ\'ees sont lus et \'ecrits
+sur plusieurs HDU cons\'ecutifs. \\
+- Juin 2006 : \\
 Ajout verification/correction noms de colonne lors de lecture FITS / DataTable, 
 et remplacement throw par un warning lors de lecture fits-healpix avec $nbcols > 1$ \\[1mm]
-Septembre-Novembre 2005 : Refondation totale du module 
+- Septembre-Novembre 2005 : Refondation totale du module 
 \begin{itemize}
 \item[\rond] Amelioration du programme PrgUtil/scanppf - 
@@ -845,7 +859,8 @@
 \end{itemize}
 
-\section{IFFTW} 
-Juillet 2007 : Passage a FFTW 3 \\
-Nov 2005 : Correction du bug dans le cas de FFT-1D Backward(complex -> reel) 
+\section{IFFTW}
+\noindent 
+- Juillet 2007 : Passage a FFTW 3 \\
+- Nov 2005 : Correction du bug dans le cas de FFT-1D Backward(complex -> reel) 
 in(1).imag() pouvait etre ecrase.
 
Index: /trunk/SophyaLib/Manual/piahelp.tex
===================================================================
--- /trunk/SophyaLib/Manual/piahelp.tex	(revision 3060)
+++ /trunk/SophyaLib/Manual/piahelp.tex	(revision 3061)
@@ -2003,5 +2003,5 @@
 \begin{verbatim} 
 Specific plot for 2D histogrammes
- h/plot/2d nameh2d show        : infos on 2D histogramme
+ h/plot/2d nameh2d show        : infos on 2D histogramme projections
  h/plot/2d nameh2d h    [dopt] : plot 2D histogramme
  h/plot/2d nameh2d px   [dopt] : plot X projection
@@ -2011,6 +2011,16 @@
  h/plot/2d nameh2d sx n [dopt] : plot X slice number n
  h/plot/2d nameh2d sy n [dopt] : plot Y slice number n
-                      n < 0 means Show Info
-\end{verbatim} 
+                      n < 0 means Show Info\end{verbatim} 
+\piacommand{h/2d/geth} \label{hZ2dZgeth} 
+\begin{verbatim} 
+Get histo projections, bandes and slices
+ h/2d/geth nameh2d         : infos on 2D histogramme projections
+ h/2d/geth h nameh2d px    : copy X projection into histo h
+ h/2d/geth h nameh2d py    : copy Y projection into histo h
+ h/2d/geth h nameh2d bx n  : copy X band number n into histo h
+ h/2d/geth h nameh2d by n  : copy Y band number n into histo h
+ h/2d/geth h nameh2d sx n  : copy X slice number n into histo h
+ h/2d/geth h nameh2d sy n  : copy Y slice number n into histo h
+  Related commands: h/plot/2d\end{verbatim} 
 \piacommand{h/put\_vec} \label{hZputZvec} 
 \begin{verbatim} 
Index: /trunk/SophyaLib/Manual/sophya.tex
===================================================================
--- /trunk/SophyaLib/Manual/sophya.tex	(revision 3060)
+++ /trunk/SophyaLib/Manual/sophya.tex	(revision 3061)
@@ -1177,4 +1177,10 @@
 may be applied onto profile histograms.
 
+\subsubsection{Histograms HistoErr}
+\index{HistoErr}
+The {\bf HistoErr} are histograms where the number of entries for each bin is kept.
+Various methods to deal with the computation of the mean in each bin
+are provided.
+
 \subsection{Data tables (tuples)}
 \begin{figure}[hbt]