Index: trunk/SophyaLib/HiStats/smakefile
===================================================================
--- trunk/SophyaLib/HiStats/smakefile	(revision 3065)
+++ trunk/SophyaLib/HiStats/smakefile	(revision 3066)
@@ -12,6 +12,6 @@
  
 $(SOPHYAOBJP)basedtable.o: basedtable.cc basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)machdefs.h \
@@ -40,6 +40,6 @@
  
 $(SOPHYAOBJP)datatable.o: datatable.cc datatable.h basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)machdefs.h \
@@ -73,29 +73,28 @@
  
 $(SOPHYAOBJP)fio_dtable.o: fio_dtable.cc datatable.h basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)segdatablock.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)objfio.h \
-  swppfdtable.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)segdatablock.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)objfio.h swppfdtable.h \
   $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)segdatablock.h \
@@ -110,6 +109,6 @@
 $(SOPHYAOBJP)hisprof.o: hisprof.cc \
   $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  hisprof.h $(SOPHYAINCP)peida.h \
+  $(SOPHYAINCP)machdefs.h hisprof.h \
+  $(SOPHYAINCP)peida.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)utils.h \
@@ -143,19 +142,18 @@
 $(SOPHYAOBJP)histerr.o: histerr.cc \
   $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  histinit.h \
+  $(SOPHYAINCP)machdefs.h histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
-  $(SOPHYAINCP)machdefs.h \
-  histerr.h $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  histos.h $(SOPHYAINCP)peida.h \
+  $(SOPHYAINCP)machdefs.h histerr.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h histos.h \
+  $(SOPHYAINCP)peida.h \
   $(SOPHYAINCP)utils.h \
   $(SOPHYAINCP)perrors.h \
@@ -180,6 +178,5 @@
 $(SOPHYAOBJP)histinit.o: histinit.cc \
   $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  histinit.h \
+  $(SOPHYAINCP)machdefs.h histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
   $(SOPHYAINCP)tarrinit.h \
@@ -211,11 +208,9 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)anydataobj.h \
-  histos2.h $(SOPHYAINCP)utils.h \
-  hisprof.h histerr.h ntuple.h ntupintf.h \
-  $(SOPHYAINCP)dvlist.h xntuple.h \
-  datatable.h basedtable.h \
-  $(SOPHYAINCP)segdatablock.h \
-  swppfdtable.h \
+  $(SOPHYAINCP)anydataobj.h histos2.h \
+  $(SOPHYAINCP)utils.h hisprof.h histerr.h \
+  ntuple.h ntupintf.h $(SOPHYAINCP)dvlist.h \
+  xntuple.h datatable.h basedtable.h \
+  $(SOPHYAINCP)segdatablock.h swppfdtable.h \
   $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)segdatablock.h \
@@ -227,6 +222,6 @@
 $(SOPHYAOBJP)histos2.o: histos2.cc \
   $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  histos2.h $(SOPHYAINCP)peida.h \
+  $(SOPHYAINCP)machdefs.h histos2.h \
+  $(SOPHYAINCP)peida.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)utils.h \
@@ -258,6 +253,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  histos2.cc
  
-$(SOPHYAOBJP)histos.o: histos.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)histos.o: histos.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h histos.h \
   $(SOPHYAINCP)objfio.h \
@@ -296,6 +290,5 @@
  
 $(SOPHYAOBJP)ntupintf.o: ntupintf.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  ntupintf.h \
+  $(SOPHYAINCP)sopnamsp.h ntupintf.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
@@ -303,6 +296,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ntupintf.cc
  
-$(SOPHYAOBJP)ntuple.o: ntuple.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)ntuple.o: ntuple.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)strutil.h \
   $(SOPHYAINCP)perrors.h \
@@ -315,6 +307,5 @@
   $(SOPHYAINCP)ppfbinstream.h \
   $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  ntupintf.h \
+  $(SOPHYAINCP)ppfnametag.h ntupintf.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)ppersist.h \
@@ -326,16 +317,14 @@
  
 $(SOPHYAOBJP)proxtuple.o: proxtuple.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  proxtuple.h ntuple.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  ntupintf.h \
+  $(SOPHYAINCP)sopnamsp.h proxtuple.h \
+  ntuple.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h ntupintf.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)ppersist.h \
@@ -347,6 +336,6 @@
  
 $(SOPHYAOBJP)swppfdtable.o: swppfdtable.cc swppfdtable.h basedtable.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)machdefs.h \
@@ -391,6 +380,6 @@
   $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)perrors.h xntuple.h \
-  $(SOPHYAINCP)machdefs.h \
-  ntupintf.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)machdefs.h ntupintf.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)anydataobj.h \
Index: trunk/SophyaLib/SysTools/Makefile
===================================================================
--- trunk/SophyaLib/SysTools/Makefile	(revision 3065)
+++ trunk/SophyaLib/SysTools/Makefile	(revision 3066)
@@ -45,5 +45,6 @@
 $(SOPHYAOBJP)cxxcmplnk.o: cxxcmplnk.cc \
   $(SOPHYAINCP)sopnamsp.h cxxcmplnk.h \
-  $(SOPHYAINCP)sspvflags.h $(SOPHYAINCP)machdefs.h
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)sspvflags.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  cxxcmplnk.cc
  
Index: trunk/SophyaLib/SysTools/smakefile
===================================================================
--- trunk/SophyaLib/SysTools/smakefile	(revision 3065)
+++ trunk/SophyaLib/SysTools/smakefile	(revision 3066)
@@ -45,5 +45,6 @@
 $(SOPHYAOBJP)cxxcmplnk.o: cxxcmplnk.cc \
   $(SOPHYAINCP)sopnamsp.h cxxcmplnk.h \
-  $(SOPHYAINCP)sspvflags.h $(SOPHYAINCP)machdefs.h
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)sspvflags.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  cxxcmplnk.cc
  