Index: trunk/SophyaLib/BaseTools/smakefile
===================================================================
--- trunk/SophyaLib/BaseTools/smakefile	(revision 3070)
+++ trunk/SophyaLib/BaseTools/smakefile	(revision 3074)
@@ -16,6 +16,6 @@
  
 $(SOPHYAOBJP)dvlist.o: dvlist.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h dvlist.h objfio.h \
-  anydataobj.h ppersist.h pexceptions.h gnumd5.h ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h dvlist.h \
+  objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h ppfbinstream.h \
   rawstream.h ppfnametag.h mutyv.h timestamp.h \
   $(SOPHYAINCP)strutil.h
@@ -23,18 +23,18 @@
  
 $(SOPHYAOBJP)fiondblock.o: fiondblock.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h pexceptions.h \
-  datatype.h fiondblock.h ppersist.h gnumd5.h ppfbinstream.h rawstream.h \
-  ppfnametag.h ndatablock.h anydataobj.h
+  $(SOPHYAINCP)machdefs.h \
+  pexceptions.h datatype.h fiondblock.h ppersist.h gnumd5.h \
+  ppfbinstream.h rawstream.h ppfnametag.h ndatablock.h anydataobj.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  fiondblock.cc
  
 $(SOPHYAOBJP)mutyv.o: mutyv.cc sopnamsp.h mutyv.h \
-  $(SOPHYAINCP)machdefs.h timestamp.h \
-  objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h ppfbinstream.h \
-  rawstream.h ppfnametag.h
+  $(SOPHYAINCP)machdefs.h \
+  timestamp.h objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h \
+  ppfbinstream.h rawstream.h ppfnametag.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  mutyv.cc
  
 $(SOPHYAOBJP)ndatablock.o: ndatablock.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h pexceptions.h \
-  ndatablock.h anydataobj.h
+  $(SOPHYAINCP)machdefs.h \
+  pexceptions.h ndatablock.h anydataobj.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ndatablock.cc
  
@@ -44,45 +44,47 @@
  
 $(SOPHYAOBJP)ppersist.o: ppersist.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h pexceptions.h \
-  ppersist.h gnumd5.h ppfbinstream.h rawstream.h ppfnametag.h \
-  anydataobj.h
+  $(SOPHYAINCP)machdefs.h \
+  pexceptions.h ppersist.h gnumd5.h ppfbinstream.h rawstream.h \
+  ppfnametag.h anydataobj.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ppersist.cc
  
 $(SOPHYAOBJP)ppfbinstream.o: ppfbinstream.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h ppfbinstream.h \
-  rawstream.h pexceptions.h
+  $(SOPHYAINCP)machdefs.h \
+  ppfbinstream.h rawstream.h pexceptions.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ppfbinstream.cc
  
 $(SOPHYAOBJP)ppftpointerio.o: ppftpointerio.cc \
-  $(SOPHYAINCP)machdefs.h sopnamsp.h \
-  ppftpointerio.h ppersist.h pexceptions.h gnumd5.h ppfbinstream.h \
-  rawstream.h ppfnametag.h
+  $(SOPHYAINCP)machdefs.h \
+  sopnamsp.h ppftpointerio.h ppersist.h pexceptions.h gnumd5.h \
+  ppfbinstream.h rawstream.h ppfnametag.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ppftpointerio.cc
  
 $(SOPHYAOBJP)rawstream.o: rawstream.cc sopnamsp.h rawstream.h \
-  $(SOPHYAINCP)machdefs.h pexceptions.h
+  $(SOPHYAINCP)machdefs.h \
+  pexceptions.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  rawstream.cc
  
 $(SOPHYAOBJP)sophyainit.o: sophyainit.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h sophyainit.h \
-  pexceptions.h ppersist.h gnumd5.h ppfbinstream.h rawstream.h \
-  ppfnametag.h fiondblock.h ndatablock.h anydataobj.h dvlist.h objfio.h \
-  mutyv.h timestamp.h fiosegdb.h segdatablock.h ppftpointerio.h \
-  ppfwrapstlv.h sversion.h
+  $(SOPHYAINCP)machdefs.h \
+  sophyainit.h pexceptions.h ppersist.h gnumd5.h ppfbinstream.h \
+  rawstream.h ppfnametag.h fiondblock.h ndatablock.h anydataobj.h \
+  dvlist.h objfio.h mutyv.h timestamp.h fiosegdb.h segdatablock.h \
+  ppftpointerio.h ppfwrapstlv.h sversion.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sophyainit.cc
  
 $(SOPHYAOBJP)timestamp.o: timestamp.cc sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h timestamp.h \
-  objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h ppfbinstream.h \
-  rawstream.h ppfnametag.h
+  $(SOPHYAINCP)machdefs.h \
+  timestamp.h objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h \
+  ppfbinstream.h rawstream.h ppfnametag.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  timestamp.cc
  
-$(SOPHYAOBJP)gnumd5.o: gnumd5.c $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)gnumd5.o: gnumd5.c \
+  $(SOPHYAINCP)machdefs.h \
   bithelp.h gnumd5.h
 	$(CCOMPILE) -o $@  gnumd5.c
  
 $(SOPHYAOBJP)srandgen.o: srandgen.c \
-  $(SOPHYAINCP)machdefs.h srandgen.h \
-  smathconst.h
+  $(SOPHYAINCP)machdefs.h \
+  srandgen.h smathconst.h
 	$(CCOMPILE) -o $@  srandgen.c
  
Index: trunk/SophyaLib/BaseTools/srandgen.c
===================================================================
--- trunk/SophyaLib/BaseTools/srandgen.c	(revision 3070)
+++ trunk/SophyaLib/BaseTools/srandgen.c	(revision 3074)
@@ -14,5 +14,5 @@
   Module 	Tirages aleatoires (C)
   Lib	LibsUtil
-  include	nbrandom.h
+  include	srandgen.h
 --
 */
@@ -169,5 +169,5 @@
 	Generation de distribution gaussienne:
 	Changement de l'initialisation de l'excursion du tirage
-	en nombre de sigmas
+	en nombre de sigmas (obsolete).
 --
 */
@@ -379,5 +379,5 @@
 /*
 ++
-|   #include "nbrandom.h"
+|   #include "srandgen.h"
 |   
 |   void main() {
@@ -512,5 +512,5 @@
   Module 	Tirages aleatoires selon une fonction (C)
   Lib	LibsUtil
-  include	nbrandom.h
+  include	srandgen.h
 --
 */