Index: trunk/SophyaLib/Samba/Makefile
===================================================================
--- trunk/SophyaLib/Samba/Makefile	(revision 3075)
+++ trunk/SophyaLib/Samba/Makefile	(revision 3077)
@@ -11,6 +11,6 @@
 	touch $(SOPHYAINCP)/SophyaConfInfo/libsophya.objlist
  
-$(SOPHYAOBJP)alm.o: alm.cc $(SOPHYAINCP)sopnamsp.h alm.h \
-  $(SOPHYAINCP)nbrandom.h \
+$(SOPHYAOBJP)alm.o: alm.cc \
+  $(SOPHYAINCP)sopnamsp.h alm.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)machdefs.h \
@@ -39,62 +39,61 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  alm.cc
  
-$(SOPHYAOBJP)bruit.o: bruit.cc $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)bruit.o: bruit.cc \
+  $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)fmath.h bruit.h \
-  $(SOPHYAINCP)nbrandom.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)machdefs.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  bruit.cc
  
-$(SOPHYAOBJP)circle.o: circle.cc $(SOPHYAINCP)sopnamsp.h \
-  circle.h $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)longlat.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)utilgeom.h \
-  $(SOPHYAINCP)unitvector.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)utilgeom.h geometry.h
+$(SOPHYAOBJP)circle.o: circle.cc \
+  $(SOPHYAINCP)sopnamsp.h circle.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)unitvector.h \
+  geometry.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  circle.cc
  
 $(SOPHYAOBJP)datacirclefake.o: datacirclefake.cc \
-  $(SOPHYAINCP)sopnamsp.h datacirclefake.h \
-  datacirclebase.h circle.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)longlat.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)utilgeom.h \
-  $(SOPHYAINCP)unitvector.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)utilgeom.h geometry.h
+  $(SOPHYAINCP)sopnamsp.h \
+  datacirclefake.h datacirclebase.h circle.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)unitvector.h \
+  geometry.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  datacirclefake.cc
  
 $(SOPHYAOBJP)harmspher.o: harmspher.cc \
-  $(SOPHYAINCP)machdefs.h harmspher.h
+  $(SOPHYAINCP)machdefs.h \
+  harmspher.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  harmspher.cc
  
 $(SOPHYAOBJP)lambdaBuilder.o: lambdaBuilder.cc \
-  $(SOPHYAINCP)sopnamsp.h lambdaBuilder.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h alm.h \
-  $(SOPHYAINCP)nbrandom.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)sopnamsp.h \
+  lambdaBuilder.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  alm.h $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)smathconst.h \
@@ -103,6 +102,7 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  lambdaBuilder.cc
  
-$(SOPHYAOBJP)mlobe.o: mlobe.cc $(SOPHYAINCP)sopnamsp.h \
-  mlobe.h $(SOPHYAINCP)sphericalmap.h \
+$(SOPHYAOBJP)mlobe.o: mlobe.cc \
+  $(SOPHYAINCP)sopnamsp.h mlobe.h \
+  $(SOPHYAINCP)sphericalmap.h \
   $(SOPHYAINCP)smathconst.h \
   $(SOPHYAINCP)machdefs.h \
@@ -133,10 +133,10 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)unitvector.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  mlobe.cc
  
 $(SOPHYAOBJP)sambainit.o: sambainit.cc \
-  $(SOPHYAINCP)sopnamsp.h sambainit.h \
+  $(SOPHYAINCP)sopnamsp.h \
+  sambainit.h \
   $(SOPHYAINCP)skymapinit.h \
   $(SOPHYAINCP)sophyainit.h \
@@ -146,14 +146,13 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sambainit.cc
  
-$(SOPHYAOBJP)scan.o: scan.cc $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)scan.o: scan.cc \
+  $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h scan.h \
   $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
   $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)objfio.h \
@@ -163,5 +162,4 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)fiondblock.h \
-  $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)smathconst.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  scan.cc
@@ -173,5 +171,4 @@
   $(SOPHYAINCP)sphericalmap.h \
   $(SOPHYAINCP)smathconst.h \
-  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pixelmap.h \
   $(SOPHYAINCP)ppersist.h \
@@ -201,12 +198,9 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fftservintf.h \
-  $(SOPHYAINCP)fftpserver.h \
-  $(SOPHYAINCP)fftservintf.h alm.h \
-  $(SOPHYAINCP)nbrandom.h \
+  $(SOPHYAINCP)fftpserver.h alm.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
-  $(SOPHYAINCP)tvector.h lambdaBuilder.h \
-  $(SOPHYAINCP)ndatablock.h \
+  lambdaBuilder.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sphericaltransformserver.cc
Index: trunk/SophyaLib/Samba/alm.h
===================================================================
--- trunk/SophyaLib/Samba/alm.h	(revision 3075)
+++ trunk/SophyaLib/Samba/alm.h	(revision 3077)
@@ -6,5 +6,5 @@
 #define ALM_SEEN
 
-#include "nbrandom.h"
+#include "srandgen.h"
 #include "nbmath.h"
 #include "triangmtx.h"
Index: trunk/SophyaLib/Samba/bruit.cc
===================================================================
--- trunk/SophyaLib/Samba/bruit.cc	(revision 3075)
+++ trunk/SophyaLib/Samba/bruit.cc	(revision 3077)
@@ -12,5 +12,5 @@
 
 #include "bruit.h"
-#include "nbrandom.h"
+#include "srandgen.h"
 // #include "rancern.h"
 // #include "hbook.h"
@@ -24,5 +24,5 @@
 // Class	NoiseGenerator
 //
-// include      bruit.h math.h fmath.h nbrandom.h
+// include      bruit.h math.h fmath.h srandgen.h
 //
 //--
@@ -88,5 +88,5 @@
 // Class	RWalkNoise
 //
-// include      bruit.h math.h fmath.h nbrandom.h
+// include      bruit.h math.h fmath.h srandgen.h
 //
 //--
@@ -143,5 +143,5 @@
 // Class	OOFNoise
 //
-// include      bruit.h math.h fmath.h nbrandom.h
+// include      bruit.h math.h fmath.h srandgen.h
 //
 //--
@@ -236,5 +236,5 @@
 // Class	EXPNoise
 //
-// include      bruit.h math.h fmath.h nbrandom.h
+// include      bruit.h math.h fmath.h srandgen.h
 //
 //--
@@ -329,5 +329,5 @@
 // Class	MemNoise
 //
-// include      bruit.h math.h fmath.h nbrandom.h
+// include      bruit.h math.h fmath.h srandgen.h
 //
 //--
@@ -627,5 +627,5 @@
 // Class	SumNoise
 //
-// include      bruit.h math.h fmath.h nbrandom.h
+// include      bruit.h math.h fmath.h srandgen.h
 //
 //    Generateur de bruit blanc + 1/f avec fknee
Index: trunk/SophyaLib/Samba/mlobe.cc
===================================================================
--- trunk/SophyaLib/Samba/mlobe.cc	(revision 3075)
+++ trunk/SophyaLib/Samba/mlobe.cc	(revision 3077)
@@ -15,5 +15,5 @@
 */
 
-// #include "nbrandom.h"
+// #include "srandgen.h"
 //++ 
 // Class	MainLobe
Index: trunk/SophyaLib/Samba/smakefile
===================================================================
--- trunk/SophyaLib/Samba/smakefile	(revision 3075)
+++ trunk/SophyaLib/Samba/smakefile	(revision 3077)
@@ -11,6 +11,6 @@
 	touch $(SOPHYAINCP)/SophyaConfInfo/libsophya.objlist
  
-$(SOPHYAOBJP)alm.o: alm.cc $(SOPHYAINCP)sopnamsp.h alm.h \
-  $(SOPHYAINCP)nbrandom.h \
+$(SOPHYAOBJP)alm.o: alm.cc \
+  $(SOPHYAINCP)sopnamsp.h alm.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)machdefs.h \
@@ -39,62 +39,61 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  alm.cc
  
-$(SOPHYAOBJP)bruit.o: bruit.cc $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)bruit.o: bruit.cc \
+  $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)fmath.h bruit.h \
-  $(SOPHYAINCP)nbrandom.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)machdefs.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  bruit.cc
  
-$(SOPHYAOBJP)circle.o: circle.cc $(SOPHYAINCP)sopnamsp.h \
-  circle.h $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)longlat.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)utilgeom.h \
-  $(SOPHYAINCP)unitvector.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)utilgeom.h geometry.h
+$(SOPHYAOBJP)circle.o: circle.cc \
+  $(SOPHYAINCP)sopnamsp.h circle.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)unitvector.h \
+  geometry.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  circle.cc
  
 $(SOPHYAOBJP)datacirclefake.o: datacirclefake.cc \
-  $(SOPHYAINCP)sopnamsp.h datacirclefake.h \
-  datacirclebase.h circle.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)longlat.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)utilgeom.h \
-  $(SOPHYAINCP)unitvector.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)utilgeom.h geometry.h
+  $(SOPHYAINCP)sopnamsp.h \
+  datacirclefake.h datacirclebase.h circle.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)unitvector.h \
+  geometry.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  datacirclefake.cc
  
 $(SOPHYAOBJP)harmspher.o: harmspher.cc \
-  $(SOPHYAINCP)machdefs.h harmspher.h
+  $(SOPHYAINCP)machdefs.h \
+  harmspher.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  harmspher.cc
  
 $(SOPHYAOBJP)lambdaBuilder.o: lambdaBuilder.cc \
-  $(SOPHYAINCP)sopnamsp.h lambdaBuilder.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h alm.h \
-  $(SOPHYAINCP)nbrandom.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)sopnamsp.h \
+  lambdaBuilder.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  alm.h $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)smathconst.h \
@@ -103,6 +102,7 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  lambdaBuilder.cc
  
-$(SOPHYAOBJP)mlobe.o: mlobe.cc $(SOPHYAINCP)sopnamsp.h \
-  mlobe.h $(SOPHYAINCP)sphericalmap.h \
+$(SOPHYAOBJP)mlobe.o: mlobe.cc \
+  $(SOPHYAINCP)sopnamsp.h mlobe.h \
+  $(SOPHYAINCP)sphericalmap.h \
   $(SOPHYAINCP)smathconst.h \
   $(SOPHYAINCP)machdefs.h \
@@ -133,10 +133,10 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)unitvector.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  mlobe.cc
  
 $(SOPHYAOBJP)sambainit.o: sambainit.cc \
-  $(SOPHYAINCP)sopnamsp.h sambainit.h \
+  $(SOPHYAINCP)sopnamsp.h \
+  sambainit.h \
   $(SOPHYAINCP)skymapinit.h \
   $(SOPHYAINCP)sophyainit.h \
@@ -146,14 +146,13 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sambainit.cc
  
-$(SOPHYAOBJP)scan.o: scan.cc $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)scan.o: scan.cc \
+  $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h scan.h \
   $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
   $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)objfio.h \
@@ -163,5 +162,4 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)fiondblock.h \
-  $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)smathconst.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  scan.cc
@@ -173,5 +171,4 @@
   $(SOPHYAINCP)sphericalmap.h \
   $(SOPHYAINCP)smathconst.h \
-  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pixelmap.h \
   $(SOPHYAINCP)ppersist.h \
@@ -201,12 +198,9 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fftservintf.h \
-  $(SOPHYAINCP)fftpserver.h \
-  $(SOPHYAINCP)fftservintf.h alm.h \
-  $(SOPHYAINCP)nbrandom.h \
+  $(SOPHYAINCP)fftpserver.h alm.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
-  $(SOPHYAINCP)tvector.h lambdaBuilder.h \
-  $(SOPHYAINCP)ndatablock.h \
+  lambdaBuilder.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sphericaltransformserver.cc
Index: trunk/SophyaLib/Samba/sphericaltransformserver.cc
===================================================================
--- trunk/SophyaLib/Samba/sphericaltransformserver.cc	(revision 3075)
+++ trunk/SophyaLib/Samba/sphericaltransformserver.cc	(revision 3077)
@@ -6,5 +6,5 @@
 #include "sphericaltransformserver.h"
 #include "tvector.h"
-#include "nbrandom.h"
+#include "srandgen.h"
 #include "nbmath.h"
 #include "timing.h"